%define statfeed_user statfeed
%define statcoll_user statcoll

Summary: Host Status Collector
Name: host-status-collector
Version: 0.3.2
Release: 1
URL: https://git.inf2.tuwien.ac.at/inf2/sw/host-status-collector
Source0: %{name}-%{version}.tar.xz
License: GPL
Group: Applications/System
BuildRoot: %{_tmppath}/%{name}-root
BuildArchitectures: noarch
Requires: bash-base >= 0.6.3
Requires: bash-range-expand >= 0.11.1
Requires: openssh-clients
Requires(pre): shadow-utils
%{?systemd_requires}
Obsoletes: zkklabs-status-collector < 0.3
Conflicts: zkklabs-status-collector < 0.3

%description
Status collector collects status info from a set of hosts and stores
state in a simple text file based database.

Note: In the client package is a default public ssh key installed, the
corresponding private key must be installed manually into
~%{statcoll_user}/.ssh on the server.

%package client
Summary: Client part of Status Collector
Group: Applications/System
Requires: openssh-server
Requires: bash-base
Requires(pre): shadow-utils
Requires: sshd-user-filter-helper
Obsoletes: zkklabs-status-collector-client < 0.3
Conflicts: zkklabs-status-collector-client < 0.3

%description client
Status collector client script. Note: This package is installed on
client computers to be observed by status collector service, which
will call it by connecting to SSH server on the client.

%prep
%setup -q

%build

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{_sharedstatedir}/%{name} \
    %{buildroot}/%{_sbindir} %{buildroot}/%{_docdir}/%{name}-%{version} \
    %{buildroot}/%{_var}/log %{buildroot}/%{_unitdir} \
    %{buildroot}/%{_sysconfdir}/sshd-user-filter/allowed.users.d \
    %{buildroot}/%{_sysconfdir}/default
cp -a sbin/* %{buildroot}/%{_sbindir}/.
cp -a host-status-collector.service %{buildroot}/%{_unitdir}/.
cp -a doc/* %{buildroot}/%{_docdir}/%{name}-%{version}/.
touch %{buildroot}/%{_var}/log/host-status-collector-service.log
echo %{statfeed_user} > %{buildroot}/%{_sysconfdir}/sshd-user-filter/allowed.users.d/host-status-collector
echo "/var/lib/host-status-collector" > \
     %{buildroot}/%{_sysconfdir}/default/host-status-collector

%pre
getent group %{statcoll_user} >/dev/null || groupadd -r %{statcoll_user}
getent passwd %{statcoll_user} >/dev/null || {
    useradd --system --create-home \
        --home-dir /home/%{statcoll_user} \
        --comment "Status collector user" \
        --gid %{statcoll_user} %{statcoll_user}
}

%pre client
getent group %{statfeed_user} >/dev/null || groupadd -r %{statfeed_user}
getent passwd %{statfeed_user} >/dev/null || {
    useradd --system --create-home \
        --home-dir /home/%{statfeed_user} \
        --comment "Status feeder user" \
        --gid %{statfeed_user} %{statfeed_user}
}

%post
%systemd_post host-status-collector.service
if (( $1 == 1 ))
then
    touch %{_var}/log/host-status-collector-service.log
    chown %{statcoll_user}:%{statcoll_user} \
        %{_var}/log/host-status-collector-service.log
fi

%post client
sshd-user-filter-helper
if (( $1 == 1 ))
then
    # allow user statfeed in sshd config if needed
    if grep -E '^[[:space:]]*AllowUsers' /etc/ssh/sshd_config
    then
        sed -ri 's#^[[:space:]]*AllowUsers[[:space:]]+(.+)$#AllowUsers \1 statfeed#' /etc/ssh/sshd_config
        systemctl restart sshd.service
    fi
fi

%preun
%systemd_preun host-status-collector.service

%postun
%systemd_postun_with_restart host-status-collector.service
if test $1 = 0
then
    userdel --remove %{statcoll_user} > /dev/null 2>&1 || \
        echo "warning: failed to remove user %{statcoll_user}" >&2
fi

%postun client
sshd-user-filter-helper
if test $1 = 0
then
    userdel --remove %{statfeed_user} > /dev/null 2>&1 || \
        echo "warning: failed to remove user %{statfeed_user}" >&2
fi

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc /usr/share/doc/%{name}-%{version}
%attr(755,root,root) %{_sbindir}/%{name}-service
%{_unitdir}/%{name}.service
%attr(750,%{statcoll_user},%{statcoll_user}) %{_sharedstatedir}/%{name}
%ghost %{_var}/log/%{name}-service.log
%config(noreplace) %{_sysconfdir}/default/host-status-collector

%files client
%defattr(-,root,root)
%attr(755,root,root) %{_sbindir}/host-status-feeder
%{_sysconfdir}/sshd-user-filter/allowed.users.d/host-status-collector
